/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.map.Role
 *  fire.pb.map.RoleManager
 *  fire.pb.map.Transfer
 *  fire.pb.scene.DynamicScene
 *  fire.pb.scene.Scene
 *  fire.pb.scene.SceneManager
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  mkdb.Mkdb
 *  mkdb.Procedure
 *  xbean.InstanceFutureInfo
 *  xbean.InstanceInfoCol
 *  xbean.InstanceTaskInfo
 *  xbean.Pod
 *  xtable.Instancefuture
 *  xtable.Roleinstancetask
 */
package fire.pb.mission.instance;

import fire.pb.map.Role;
import fire.pb.map.RoleManager;
import fire.pb.map.Transfer;
import fire.pb.mission.instance.InstanceManager;
import fire.pb.mission.instance.InstanceTimeOut;
import fire.pb.scene.DynamicScene;
import fire.pb.scene.Scene;
import fire.pb.scene.SceneManager;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import java.util.LinkedList;
import java.util.List;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import mkdb.Mkdb;
import mkdb.Procedure;
import xbean.InstanceFutureInfo;
import xbean.InstanceInfoCol;
import xbean.InstanceTaskInfo;
import xbean.Pod;
import xtable.Instancefuture;
import xtable.Roleinstancetask;

public class PLeaveInstanceMapProc
extends Procedure {
    private final long leaveRoleId;
    private final int gotoType;

    public PLeaveInstanceMapProc(long roleId, int gotoType) {
        this.leaveRoleId = roleId;
        this.gotoType = gotoType;
    }

    protected boolean process() throws Exception {
        Team team = TeamManager.selectTeamByRoleId((long)this.leaveRoleId);
        LinkedList<Long> allRoleIDs = new LinkedList<Long>();
        if (team == null) {
            allRoleIDs.add(this.leaveRoleId);
        } else if (team.getTeamLeaderId() == this.leaveRoleId) {
            allRoleIDs.addAll(team.getNormalMemberIds());
        }
        Role mapRole = RoleManager.getInstance().getRoleByID(this.leaveRoleId);
        if (mapRole == null) {
            return false;
        }
        long scenceId = mapRole.getScene();
        Scene scence = SceneManager.getInstance().getSceneByID(scenceId);
        if (scence == null) {
            return false;
        }
        InstanceInfoCol taskInfo = Roleinstancetask.select((Long)this.leaveRoleId);
        if (taskInfo == null) {
            return false;
        }
        InstanceTaskInfo info = (InstanceTaskInfo)taskInfo.getInstinfo().get(taskInfo.getLastinstanceid());
        if (info == null) {
            return false;
        }
        if (info.getInstanceflag() == 2) {
            InstanceManager.getInstance().refreshTaskState(this.leaveRoleId, info.getCurrenttaskid(), 5);
        }
        boolean destory = true;
        List<Integer> mapList = InstanceManager.getInstance().getInstanceMapId(taskInfo.getLastinstanceid());
        for (Integer mapId : mapList) {
            DynamicScene ds = SceneManager.getInstance().getSceneByMapAndOwner(mapId.intValue(), info.getInstanceonlyid());
            if (ds == null || ds.getSceneRoles().size() <= 0) continue;
            destory = false;
            break;
        }
        if (destory) {
            ScheduledFuture future = Mkdb.executor().schedule((Runnable)new InstanceTimeOut(info.getInstanceonlyid(), taskInfo.getLastinstanceid()), 600L, TimeUnit.SECONDS);
            InstanceFutureInfo futureInfo = Instancefuture.get((Long)info.getInstanceonlyid());
            if (futureInfo == null) {
                futureInfo = Pod.newInstanceFutureInfo();
                Instancefuture.insert((Long)info.getInstanceonlyid(), (InstanceFutureInfo)futureInfo);
            }
            futureInfo.setTimeoutfuture(future);
        }
        if (this.gotoType == 0) {
            return Transfer.justGotoWhileCommit((long)this.leaveRoleId, (long)1615L, (int)102, (int)104, (int)516017);
        }
        return true;
    }
}

